package gov.va.shared.service;

import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.util.Collection;

import org.springframework.security.core.userdetails.UserDetailsService;

import gov.va.shared.model.AppUser;

public interface AppUserService extends UserDetailsService {

	int updateFieldsWithoutVersionCheck(long appUserID, boolean incrementVersion, Long lastVisitedDutyStationNumber,
			boolean setAccountLockDate, ZonedDateTime accountLockDate, Integer failedLoginCount);

	void logApplicationAccess(String activeDirectoryName, ZonedDateTime now);

	AppUser saveOrUpdate(AppUser appUser);

	/* For application-internal code only */
	AppUser saveOrUpdateWithoutAuthority(AppUser appUser);

	AppUser updateUser(long userId, Boolean enabled, Boolean locked, Boolean expired, ZoneId timezone,
			boolean updateRolesAndFacilities, Long defaultFacilityId, Collection<Long> globalRoles,
			Collection<Long> vaFacilityIds);

	String updatePassword(long appUserId, String plaintextPassword);

	/**
	 * Removes the specified user from the system. Returns true if the user was
	 * successfully removed; false if the user could not be removed due to
	 * app-specific foreign key constraints - CPB
	 */
	boolean removeUser(long appUserId);

	AppUser customizeUser(long userId, Collection<Long> roles, Collection<Long> vaFacilities);

	AppUser createOrRetrieveUser(String activeDirectoryName, CreateOrRetrieveUserCallback callback);

	AppUser updateUserFromLDAP(long appUserId, boolean checkAuthority);

}
