package gov.va.shared.persistence;

import java.util.SortedSet;

import org.junit.Test;
import org.springframework.util.Assert;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.shared.test.AbstractDAOTest;

public class TestVAFacilityDAO extends AbstractDAOTest<VAFacility> {

	@Override
	protected VAFacility getInstanceToSave() {
		return null;
	}

	@Override
	protected AppDAO<VAFacility> getDAO() {
		return vaFacilityDAO;
	}

	@Override
	protected boolean testDelete() {
		return false;
	}

	@Test
	public void testFindAllVAMCsSorted() {
		SortedSet<VAFacility> vamcs = vaFacilityDAO.findAllThreeDigitStationsSorted();
		for (VAFacility vamc : vamcs) {
			System.out.println("VAMC found: " + vamc.getDisplayName());
		}
		System.out.println("vamcs.size() " + vamcs.size());
		// for (VAFacility vamc : vamcs) {
		// System.out.println("\t" + vamc);
		// }
	}

	@Test
	public void testFindAllVISNSSorted() {
		SortedSet<VAFacility> visns = vaFacilityDAO.findAllVISNsSorted();
		for (VAFacility visn : visns) {
			System.out.println("VISN found: " + visn.getDisplayName());
		}
		System.out.println("visns.size() " + visns.size());
	}

	@Test
	public void testFindAllSorted() {
		SortedSet<VAFacility> facs = vaFacilityDAO.findAllSorted();
		for (VAFacility fac : facs) {
			System.out.println("Facility found: " + fac.getDisplayName());
		}
		System.out.println("facs.size() " + facs.size());
	}

	@Test
	public void testFindByStationNumber() {
		VAFacility i = vaFacilityDAO.findByStationNumber("442");
		Assert.notNull(i, "The object was not found");
	}

}
