package gov.va.shared.service.impl;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.AuthenticationCredentialsNotFoundException;
import org.springframework.security.test.context.support.WithMockUser;

import gov.va.shared.AbstractCoreTransactionalAppTest;
import gov.va.shared.model.AppUser;
import gov.va.shared.service.AppUserService;

public class TestAppUserServiceImpl extends AbstractCoreTransactionalAppTest {

	@Autowired
	private AppUserService appUserService;

	@Test(expected = AuthenticationCredentialsNotFoundException.class)
	public void testDeleteUserProfileAnonymous() {
		appUserService.saveOrUpdate(new AppUser());
	}

	@Test(expected = IllegalArgumentException.class)
	@WithMockUser(roles = { "USER_PROFILE_ADMIN" })
	public void testDeleteUserProfileAuthenticated() {
		appUserService.saveOrUpdate(new AppUser());
	}

}
