CREATE VIEW [sdsadm].[STD_Institution_IndxView]
WITH SCHEMABINDING
As
select id,'isActive' = 
case   
     when(cast(ISNULL(deactivationDate,0) as char)) like 'Jan  1 1900 12:00AM%' then '1'
	 when activationdate > deactivationdate then '1'
           else '0'
       end, [activationDate]
           ,[deactivationDate]
           ,[name]
           ,[stationNumber]
           ,[vistaName]
           ,[agency_id]
           ,[streetCountry_id]
           ,[streetAddressLine1]
           ,[streetAddressLine2]
           ,[streetAddressLine3]
           ,[streetCity]
           ,[streetState_id]
           ,[streetCounty_id]
           ,[streetPostalCode]
           ,[mailingCountry_id]
           ,[mailingAddressLine1]
           ,[mailingAddressLine2]
           ,[mailingAddressLine3]
           ,[mailingCity]
           ,[mailingState_id]
           ,[mailingCounty_id]
           ,[mailingPostalCode]
           ,[facilityType_id]
           ,[mfn_zeg_recipient]
           ,[parent_id]
           ,[realignedFrom_id]
           ,[realignedTo_id]
           ,[visn_id]
           ,[version]
           ,[created]
           ,[updated]
           ,[createdBy]
           ,[updatedBy]
from sdsadm.STD_institution;
GO

update CORE.APP_USER set PASSWORD_HASH = '$2a$10$.t6NFiFC7okvn.0mzFKGyu4zofXP0Ap43e5iDJPyFo9zcK1BB2LdK'
where USERNAME = 'vhaisdbarryc'
GO

INSERT INTO [CORE].[PERMISSION]
           ([NAME]
           ,[DESCRIPTION]
           ,[SORT_ORDER]
           ,[EFFECTIVE_DATE]
           ,[EXPIRATION_DATE]
           ,[CREATED_BY]
           ,[CREATED_DATE]
           ,[MODIFIED_BY]
           ,[MODIFIED_DATE])
     VALUES
           ('VOLUNTEER_VIEW'
           ,'VOLUNTEER_VIEW'
           ,0
           ,'1900-01-01'
           ,null
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME()
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME())
GO

INSERT INTO [CORE].[PERMISSION]
           ([NAME]
           ,[DESCRIPTION]
           ,[SORT_ORDER]
           ,[EFFECTIVE_DATE]
           ,[EXPIRATION_DATE]
           ,[CREATED_BY]
           ,[CREATED_DATE]
           ,[MODIFIED_BY]
           ,[MODIFIED_DATE])
     VALUES
           ('VOLUNTEER_EDIT'
           ,'VOLUNTEER_EDIT'
           ,0
           ,'1900-01-01'
           ,null
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME()
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME())
GO

INSERT INTO [CORE].[PERMISSION]
           ([NAME]
           ,[DESCRIPTION]
           ,[SORT_ORDER]
           ,[EFFECTIVE_DATE]
           ,[EXPIRATION_DATE]
           ,[CREATED_BY]
           ,[CREATED_DATE]
           ,[MODIFIED_BY]
           ,[MODIFIED_DATE])
     VALUES
           ('VOLUNTEER_DELETE'
           ,'VOLUNTEER_DELETE'
           ,0
           ,'1900-01-01'
           ,null
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME()
           ,'vhaisdbarryc'
           ,SYSUTCDATETIME())
GO

INSERT INTO [CORE].[ROLE_PERMISSION]
           ([ROLE_ID]
           ,[PERMISSION_ID]
           ,[CREATED_BY]
           ,[CREATED_DATE]
           ,[MODIFIED_BY]
           ,[MODIFIED_DATE])
select r.ROLE_ID,
	p.PERMISSION_ID,
	'vhaisdbarryc',
	SYSUTCDATETIME(),
	'vhaisdbarryc',
	SYSUTCDATETIME()
from CORE.ROLE r,
	CORE.PERMISSION p
where r.NAME = 'USER_ROLE'
	and p.PERMISSION_ID not in (select PERMISSION_ID from CORE.ROLE_PERMISSION where ROLE_ID =
		(select ROLE_ID from CORE.ROLE where NAME = 'USER_ROLE'))
GO