package gov.va.vss.service.cluster;

public enum ClusterLockType {
	/* */
	CPRS_HEADER_SYNC_STATION("CPRSHeaderSync_station_"),
	/* */
	CPRS_HEADER_SYNC_PATIENT("CPRSHeaderSync_patient_"),
	/* */
	CPRS_HEADER_SYNC_MONITOR("CPRSHeaderSyncMonitor"),
	/* */
	TEAM_VALIDATION("TeamValidation_"), //
	/* */
	VISTA_SYNC("VistaSync_"), //
	/* */
	VISTA_CLEANUP("VistaCleanup_"), //
	/* */
	VISTA_STATION_DATA("VistaStationData_getOrCreate_"), //
	/* */
	PATIENT_AUTO_INACTIVATION("PatientAutoInactivation_station_"), //
	/* */
	MVI_PRIMARY_VIEW_AND_REGISTRATION("MVIPrimaryViewAndRegistration_"), //
	/* */
	MULTI_PCP_APPROVAL_ESCALATION("MultiPCPApprovalEscalation"), //
	/* */
	STAFF_UPDATE("StaffUpdate_station_"), //
	/* */
	MODELED_CAPACITY_CALCULATION("ModeledCapacityCalculation_");

	private String prefix;

	/**
	 * @param qualifier
	 *            The unique qualifier for this type of lock (must not be null)
	 * @return the lock name for the specified type and qualifier
	 */
	public String getLockName(Object qualifier) {
		if (qualifier == null)
			throw new NullPointerException("The specified qualifier must not be null");

		return prefix + qualifier;
	}

	private ClusterLockType(String prefix) {
		this.prefix = prefix;
	}

}
