package gov.va.vss.service.impl;

import org.springframework.batch.core.explore.JobExplorer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.MessageSource;
import org.springframework.transaction.annotation.Transactional;

import com.hazelcast.core.HazelcastInstance;

import gov.va.shared.persistence.AppUserDAO;
import gov.va.shared.persistence.lookup.sds.GenderDAO;
import gov.va.shared.persistence.lookup.sds.StateDAO;
import gov.va.shared.persistence.lookup.sds.VAFacilityDAO;
import gov.va.shared.persistence.lookup.sds.VAFacilityTypeDAO;
import gov.va.vss.persistence.dao.ApplicationParametersDAO;
import gov.va.vss.persistence.dao.BinaryObjectDAO;
import gov.va.vss.persistence.dao.ExcludedEntityDAO;
import gov.va.vss.persistence.dao.OrganizationDAO;
import gov.va.vss.persistence.dao.ServiceParametersDAO;
import gov.va.vss.persistence.dao.TemplateDAO;
import gov.va.vss.persistence.dao.VistaStationDataDAO;
import gov.va.vss.persistence.dao.VoluntaryServiceStaffDAO;
import gov.va.vss.persistence.dao.VolunteerDAO;
import gov.va.vss.persistence.dao.VtkUserDAO;
import gov.va.vss.persistence.dao.audit.AuditLogEntryDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionMetadataDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultItemDAO;
import gov.va.vss.persistence.dao.lookup.ActiveStatusDAO;
import gov.va.vss.persistence.dao.lookup.VtkAdministrativeUnitDAO;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionDAO;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionTypeDAO;
import gov.va.vss.persistence.dao.lookup.VtkStateDAO;
import gov.va.vss.persistence.dao.views.FacilityAndVisnDAO;
import gov.va.vss.service.cluster.ClusterInstanceName;
import gov.va.vss.service.email.EmailService;

@Transactional
public class AbstractServiceImpl {

	@Autowired
	protected ActiveStatusDAO activeStatusDAO;
	@Autowired
	protected ApplicationParametersDAO applicationParametersDAO;
	@Autowired
	protected AppUserDAO appUserDAO;
	@Autowired
	protected AuditLogEntryDAO auditLogEntryDAO;
	@Autowired
	protected BinaryObjectDAO binaryObjectDAO;
	@Autowired
	protected ExcludedEntityDAO excludedEntityDAO;
	@Autowired
	protected GenderDAO genderDAO;
	@Autowired
	protected FacilityAndVisnDAO facilityAndVisnDAO;
	@Autowired
	protected OrganizationDAO organizationDAO;
	@Autowired
	protected JobExecutionMetadataDAO jobExecutionMetadataDAO;
	@Autowired
	protected JobExecutionResultDAO jobExecutionResultDAO;
	@Autowired
	protected JobExecutionResultItemDAO jobExecutionResultItemDAO;
	@Autowired
	protected StateDAO stateDAO;
	@Autowired
	protected TemplateDAO templateDAO;
	@Autowired
	protected VAFacilityDAO vaFacilityDAO;
	@Autowired
	protected VAFacilityTypeDAO vaFacilityTypeDAO;
	@Autowired
	protected VistaStationDataDAO vistaStationDataDAO;
	@Autowired
	protected VolunteerDAO volunteerDAO;
	@Autowired
	protected VtkAdministrativeUnitDAO vtkAdministrativeUnitDAO;
	@Autowired
	protected VtkInstitutionDAO vtkInstitutionDAO;
	@Autowired
	protected VtkInstitutionTypeDAO vtkInstitutionTypeDAO;
	@Autowired
	protected VtkStateDAO vtkStateDAO;
	@Autowired
	protected ServiceParametersDAO serviceParametersDAO;
	@Autowired 
	protected VoluntaryServiceStaffDAO voluntaryServiceStaffDAO;
	@Autowired
	protected VtkUserDAO vtkUserDAO;
	@Autowired
	protected EmailService emailService;
	@Autowired
	@Qualifier(ClusterInstanceName.UNATTENDED)
	protected HazelcastInstance clusterOpsUnattendedOnly;
	@Autowired
	protected MessageSource messageSource;

	@Autowired
	protected JobExplorer jobExplorer;

}
