package gov.va.vss.web.batch;

import java.util.ArrayList;
import java.util.List;

public enum BatchActionType {
	SOME_BATCH_TYPE("SomeBatchType", "SomeBatchType");

	private String code;
	private String name;

	private BatchActionType(String code, String name) {
		this.code = code;
		this.name = name;
	}

	public String getCode() {
		return code;
	}

	public String getName() {
		return name;
	}

	public static List<BatchActionType> getForCodes(String[] codes) {
		List<BatchActionType> results = new ArrayList<>();
		for (String code : codes) {
			BatchActionType type = getForCode(code);
			if (type != null)
				results.add(type);
		}
		return results;
	}

	public static BatchActionType getForCode(String code) {
		for (BatchActionType type : values()) {
			if (type.getCode().equals(code))
				return type;
		}
		return null;
	}
}
