package gov.va.vss.config.testOnly;

import javax.jms.ConnectionFactory;
import javax.naming.NamingException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.jms.annotation.EnableJms;

import com.mockrunner.jms.ConfigurationManager;
import com.mockrunner.jms.DestinationManager;
import com.mockrunner.mock.jms.MockQueueConnectionFactory;

@Configuration
@EnableJms
public class MessagingTestConfig {

	@Autowired
	private Environment env;

	@Bean
	public ConnectionFactory jmsConnectionFactory() throws IllegalArgumentException, NamingException {
		MockQueueConnectionFactory cf = new MockQueueConnectionFactory(new DestinationManager(),
				new ConfigurationManager());
		return cf;
	}

}
