package gov.va.vss.persistence.dao;

import java.util.Collection;
import java.util.List;

import gov.va.vss.model.Volunteer;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

public interface VolunteerDAO extends CustomizableSortedDAO<Volunteer> {

	/**
	 * 
	 * @param middleName
	 *            TODO
	 * @param code TODO
	 * @param addressStreet
	 *            TODO
	 * @param city TODO
	 * @param state TODO
	 * @param zip TODO
	 * @param phone TODO
	 * @param email TODO
	 * @param vaFacilityIds
	 *            The IDs of the VAFacilities that are associated with the
	 *            Volunteer. These are assumed to all be VAMC (3-digit station)
	 *            IDs; if any ID is passed in which belongs to a non-VAMC
	 *            station (either a 5+ digit CBOC or a VISN) it will be ignored
	 *            since Volunteers can only be associated to VAMCs.
	 * @param customization
	 *            An optional QueryCustomization
	 * @param name
	 *            All or part of the first name (case-insensitive)
	 * @param wildcardName
	 *            All or part of the last name (case-insensitive)
	 * @param sta3ns
	 *            The 3-digit station numbers associated with the volunteer. If
	 *            any of these are greater than three digits, an
	 *            IllegalArgumentException is thrown.
	 * @return The list of Volunteers matching the above criteria
	 */
	List<Volunteer> findByCriteria(String firstName, String middleName, String lastName, String code,
			String addressStreet, String city, String state, String zip, String phone, String email, Collection<Long> vaFacilityIds, Collection<String> vaFacilitySta3ns, QueryCustomization... customization);

}
