package gov.va.vss.persistence.impl.lookup;

import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

import org.springframework.stereotype.Repository;

import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.vss.model.lookup.VtkInstitution;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionDAO;
import gov.va.vss.persistence.impl.GenericHibernateSortedDAOImpl;

@Repository
public class VtkInstitutionDAOImpl extends GenericHibernateSortedDAOImpl<VtkInstitution> implements VtkInstitutionDAO {

	public VtkInstitution findByStationNumber(String stationNumber) {
		@SuppressWarnings("unchecked")
		List<VtkInstitution> results = query(
				"from " + VtkInstitution.class.getName() + " where stationNumber = :stationNumber")
						.setParameter("stationNumber", stationNumber).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

	@Override
	public VtkInstitution findBySDSFacility(long vaFacilityId) {
		@SuppressWarnings("unchecked")
		List<VtkInstitution> results = query(
				"from " + VtkInstitution.class.getName() + " where vaFacility.id = :vaFacilityId")
						.setParameter("vaFacilityId", vaFacilityId).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

	@Override
	public SortedSet<VAFacility> findVAFacilitiesWithLinkToVtkInstitution() {
		@SuppressWarnings("unchecked")
		List<VAFacility> results = query(
				"select i.vaFacility from " + VtkInstitution.class.getName() + " i where i.vaFacility is not null").getResultList();
		return new TreeSet<>(results);
	}

}
