package gov.va.vss.service.scheduledJobs;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.transaction.PlatformTransactionManager;

import com.hazelcast.core.HazelcastInstance;

import gov.va.shared.model.AppUser;
import gov.va.shared.persistence.AppUserDAO;
import gov.va.shared.persistence.LdapPersonDAO;
import gov.va.shared.persistence.lookup.sds.VAFacilityDAO;
import gov.va.shared.service.AppUserService;
import gov.va.shared.util.SecurityUtil;
import gov.va.vss.persistence.dao.ApplicationParametersDAO;
import gov.va.vss.persistence.dao.VistaStationDataDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionMetadataDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultDAO;
import gov.va.vss.persistence.dao.lookup.JobExecutionTypeDAO;
import gov.va.vss.persistence.dao.views.FacilityAndVisnDAO;
import gov.va.vss.service.ExcludedEntityService;
import gov.va.vss.service.JobExecutionMetadataService;
import gov.va.vss.service.VistaStationDataService;
import gov.va.vss.service.batch.JobExecutionResultItemService;
import gov.va.vss.service.batch.JobExecutionResultService;
import gov.va.vss.service.cluster.ClusterInstanceName;
import gov.va.vss.service.messaging.listeners.CommonEventsJMSService;

public abstract class AbstractScheduledJob {

	@Autowired
	protected ApplicationParametersDAO applicationParametersDAO;
	@Autowired
	protected AppUserDAO appUserDAO;
	@Autowired
	protected AppUserService appUserService;
	@Autowired
	protected CommonEventsJMSService commonEventsJMSService;
	@Autowired
	protected VAFacilityDAO vAFacilityDAO;
	@Autowired
	protected FacilityAndVisnDAO institutionAndVisnDAO;
	@Autowired
	protected ExcludedEntityService excludedEntityService;
	@Autowired
	protected JobExecutionMetadataDAO jobExecutionMetadataDAO;
	@Autowired
	protected JobExecutionMetadataService jobExecutionMetadataService;
	@Autowired
	protected JobExecutionResultDAO jobExecutionResultDAO;
	@Autowired
	protected JobExecutionResultService jobExecutionResultService;
	@Autowired
	protected JobExecutionResultItemService jobExecutionResultItemService;
	@Autowired
	protected JobExecutionTypeDAO jobExecutionTypeDAO;
	@Autowired
	protected LdapPersonDAO ldapPersonDAO;
	@Autowired
	protected VistaStationDataDAO vistaStationDataDAO;
	@Autowired
	protected VistaStationDataService vistaStationDataService;

	@Autowired
	@Qualifier("transactionManager")
	protected PlatformTransactionManager tm;
	@Autowired
	@Qualifier(ClusterInstanceName.UNATTENDED)
	protected HazelcastInstance clusterOpsUnattendedOnly;

	protected AppUser queryUser() {
		return appUserDAO.findByUsername(SecurityUtil.getCurrentUserName(), false);
	}

}
