package gov.va.vss.web;

import java.time.ZoneId;
import java.time.ZonedDateTime;

import org.springframework.format.annotation.DateTimeFormat;

import gov.va.shared.model.lookup.ActiveStatus.ActiveStatusType;
import gov.va.vss.util.DateUtil;

public class TimelineCommand {

	private ActiveStatusType status = ActiveStatusType.ACTIVE;
	private String reasonCode;

	@DateTimeFormat(pattern = DateUtil.TWO_DIGIT_MILITARY_DATE_TIME)
	private ZonedDateTime effectiveDate;

	public TimelineCommand(ZoneId userZone) {
		effectiveDate = ZonedDateTime.now().withZoneSameInstant(userZone);
	}

	public ActiveStatusType getStatus() {
		return status;
	}

	public void setStatus(ActiveStatusType status) {
		this.status = status;
	}

	public String getReasonCode() {
		return reasonCode;
	}

	public void setReasonCode(String reasonCode) {
		this.reasonCode = reasonCode;
	}

	public ZonedDateTime getEffectiveDate() {
		return effectiveDate;
	}

	public void setEffectiveDate(ZonedDateTime effectiveDate) {
		this.effectiveDate = effectiveDate;
	}

}
