<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">
$(function() {
	$('#warning').html('').hide()
	$('#statusUpdateFormDiv').dialog({
		autoOpen: false,
		modal: true,
		width: 560,
		height: 350,
		show: 'slide',
		closeOnEscape: false,
		draggable: true,
		resizable: true,
		buttons: {
			'Submit': statusManagementSubmit,
			'Cancel': function() {
				$('#warning').html('').hide()
				$(this).dialog('close');
			}
		}
	})
	
	$('#show_hide').showHide({
		speed : 500, // speed you want the toggle to happen
		easing : '', // the animation effect you want. Remove this line if you dont want an effect and if you haven't included jQuery UI
		changeText : 1, // if you dont want the button text to change, set this to 0
		showText : 'View/Edit Complete Timeline',// the button text to show when a div is closed
		hideText : 'Close Timeline' // the button text to show when a div is open
	})

	$('#effectiveDate').enableDateTimePicker({
		showOn : "button",
		buttonImage : "/images/calendar.gif",
		buttonImageOnly : true
	})
	$("#effectiveDate").mask("${TWO_DIGIT_DATE_TIME_MASK}")
	
	refreshStatusTimelineWidgets()
})

function loadStatusTimeLine() {
	$.ajax({
		url : '${param.statusTimelineUrl}',
		error : function(jqXHR, textStatus, errorThrown) {
			displayAttentionDialog("Error while retrieving timeline " + textStatus)
		},
		success : function(response) {
			if (checkAndHandleAjaxError(response)) return
			var r = response.ajaxResult
			
			if (r.length == 0) {
				$('#statusHistoryDiv')
						.html("There are no timeline items to display.");
			} else {
				var strBuf = "<table id='historyTbl' border='1' cellpadding='3' width='90%'><thead><tr>" +
						"<th width='18%'>Valid From</th>" +
						"<th width='18%'>Valid To</th>" +
						"<th width='18%'>Status</th>" +
						"<th width='18%'>Reason</th>" +
						"<th nowrap width='18%'>Requested By</th>" +
						"<th nowrap width='10%'>Actions</th>" +
						"</tr></thead><tbody>";

				for (var i = 0; i < r.length; i++) {
					var startDate = new Date(r[i]["effectiveDate"])
					var startDateStr = new XDate(r[i]["effectiveDate"]).toString('${TWO_DIGIT_MILITARY_DATE_TIME}')
					var endDate = (i == 0) ? 'Onward' : new XDate(r[i - 1]["effectiveDate"]).toString('${TWO_DIGIT_MILITARY_DATE_TIME}')
					var deleteIcon = (r.length > 1) ?  " <a class='delete confirm' alt='Delete Entry' title='Are you sure you want to delete this entry?' href='javascript:deleteStatusItem(" + r[i].id + ")'> </a>" : "";
					
					strBuf += "<tr><td nowrap align='center'>"
							+ startDateStr
							+ "</td><td align='center'>"
							+ endDate
							+ "</td><td align='center'>"
							+ escapeHTML(r[i].status.name)
							+ "</td><td nowrap align='center'>"
							+ escapeHTML(r[i].statusChangeReason.name)
							+ "</td><td align='center'>"
							+ escapeHTML(r[i].recordCreatedBy)
							+ "</td><td align='center'>"
							<sec:authorize access="hasAnyAuthority('${CISS_PERMISSION_TYPE_UPDATE_PC_TEAM}', '${CISS_PERMISSION_TYPE_UPDATE_MH_TEAM}', '${CISS_PERMISSION_TYPE_UPDATE_SPECIALTY_TEAM}', '${CISS_PERMISSION_TYPE_UPDATE_NONVA_CARE_TEAM}')">
							<c:if test="${not FORM_READ_ONLY}">	
							+ "<a class='edit' title='Edit Entry' href='javascript:editStatusItem(" + r[i].id + 
									"," + r[i].status.id + "," + startDate.getTime() + ",\"" + 
									escapeHTML(r[i].statusChangeReason.code) + "\")'></a>"
							+ deleteIcon
							</c:if>
							</sec:authorize>
							+ "</td></tr>";
				}
				strBuf += "</tbody></table>";
				$('#statusHistoryDiv').html(strBuf);
				<c:if test="${not empty param.confirmTitle}">
					$('.manage').addClass('confirm').attr('title','${param.confirmTitle}').attr('alt', 'Edit Entry')
					$('.delete').addClass('confirm').attr('title','${param.confirmTitle}').attr('alt', 'Delete Entry')
					$('#createNewTimelineItem').addClass('confirm').attr('title','${param.confirmTitle}').attr('alt', 'Add Entry')
				</c:if>
				$(".confirm").easyconfirm()
			}
		}
	})
}

function getCurrentStatus() {
	$.ajax({
		url : '${param.statusGetUrl}', 
		success : function(response) {
			if (checkAndHandleAjaxError(response)) return
			var r = response.ajaxResult
			
			var dateEffective = 'Unknown'
			var currentStatusName = 'Unknown';
			var currentStatusReason = 'Unknown';

			if (r != null) {
				dateEffective = new XDate(r["effectiveDate"]).toString('${MILITARY_DATE_TIME}')
				
				currentStatusName = r["status"]["name"];
				currentStatusReason = r["statusChangeReason"]["name"];
			}
			
			if ($('#curentStatusSpan').length) {
				var statusText = 'Currently the <c:out value="${param.objectType}" /> status is <b>' +
					escapeHTML(currentStatusName) + "</b>"
				
				if (currentStatusReason != 'Unknown')
					statusText += (' with a reason of <b>' + escapeHTML(currentStatusReason) + "</b>")
			
				if (dateEffective != 'Unknown')
					statusText += (' since <b>' + dateEffective + '</b>')
					
				statusText += '.'
				$('#curentStatusSpan').html(statusText)
			}
			
			if (currentStatusName == 'Active') {
				//Set statusId to 2 (inactive - since we will be inactivating the object)
				$('#statusId').val(2);
			} else {
				//Set statusId to 1 (active - since we will be activating the object)
				$('#statusId').val(1);
			}
		}
	})
}

function validateStatusChangeInputs() {
	if (!militaryZonedDateTimeRegex.test($('#effectiveDate').val())) {
		displayAttentionDialog('Please specify a valid effective date in "mm/dd/yyyy hh:mm" format!')
		return false
	}
	
	if ($('#statusChangeReason').val() == "") {
		displayAttentionDialog("Please select a reason for the status change!")
		return false
	}

	return true
}

function refreshStatusTimelineWidgets() {
	loadStatusTimeLine()
	getCurrentStatus()
}

function createNewTimelineItem() {
	$('#updateTimelineEventId').val("")
	$('#effectiveDate').val(new XDate().toString('${TWO_DIGIT_MILITARY_DATE_TIME}'))
	$('#statusChangeReason').val("")
	$('#statusUpdateFormDiv').dialog('option', 'title', "Add Entry").dialog("open")
}

function editStatusItem(timelineEventId, statusId, effectiveDateMillis, reasonCode) {
	$('#updateTimelineEventId').val(timelineEventId)
	$('#statusId').val(statusId);
	$('#effectiveDate').val(new XDate(effectiveDateMillis).toString('${TWO_DIGIT_MILITARY_DATE_TIME}'))
	$('#statusChangeReason').val(reasonCode)
	$('#statusUpdateFormDiv').dialog('option', 'title', "Update Entry").dialog("open")
}

function deleteStatusItem(timelineEventId) {
	$.ajax({
		url: '${param.statusDeleteUrl}',
		data: {
			timelineEventId: timelineEventId
		},
		dataType: 'json',
		cache: false,
		success: function(response) {
			if (checkAndHandleAjaxError(response)) return
			var r = response.ajaxResult;
			
			displayAttentionDialog(r.statusMessage ? r.statusMessage :
				"The timeline event was successfully deleted.");
			refreshStatusTimelineWidgets();
		},
		error: function(jqXHR, textStatus, errorThrown) {
			displayAttentionDialog("Error while managing the status timeline: " + textStatus)
		}
	})
}

function statusManagementSubmit() {
	var warning = '${param.warning}'.trim()
	if(warning.length==0 || $('#warning').is(':visible') || $('#statusId').val()==1) {
		 if (!validateStatusChangeInputs()) return
		
		  $.ajax({
			  url: '${param.statusUpdateUrl}',
			  data: {
				    timelineEventId : $('#updateTimelineEventId').val(),
				    statusId: $('#statusId').val(),
				    statusChangeReason: $('#statusChangeReason').val(),
				    effectiveDate: $('#effectiveDate').val()
			  },
			  dataType: 'json',
			  cache: false,
			  success: function(response) {
				    if (checkAndHandleAjaxError(response)) return
				    var r = response.ajaxResult;
			
				    $('#statusUpdateFormDiv').dialog("close");
				    displayAttentionDialog(r.statusMessage ? r.statusMessage :
				        "The timeline was successfully modified.");
				    refreshStatusTimelineWidgets();
			  },
			  error: function(jqXHR, textStatus, errorThrown) {
				   displayAttentionDialog("Error while managing the status timeline: " + textStatus)
		      }
		})
	} else {
		var warning = warning + "<br/>Please click Submit to continue."
		$('#warning').html(warning).show()
	}
}
</script>

<table width="100%">
	<tr>
		<td width="100%">
			<fieldset style="border: 1px solid black;">
				<legend>Status Change Timeline:</legend>
				<table align="center" cellpadding="5" width="100%">
					<tr align="center">
						<td><span id='curentStatusSpan'>Retrieving status...</span></td>
					</tr>
					<tr align="center">
						<td width="100%" align="center"><a class="appLink"
							id="show_hide" href="#" rel="#slidingDiv"> <c:choose>
									<c:when test="${FORM_READ_ONLY}">
								View Complete Timeline
							</c:when>
									<c:otherwise>	
									View/Edit Complete Timeline
							</c:otherwise>
								</c:choose>

						</a></td>
					</tr>
					<tr align="center">
						<td width="100%">
							<div id="slidingDiv" class="toggleDiv" style="display: none;">
								<div id="statusHistoryDiv"></div>

								<c:if test="${not FORM_READ_ONLY}">
									<br>
									<a id="createNewTimelineItem" class="buttonAnchor"
										href="javascript:createNewTimelineItem()">Add Entry</a>
								</c:if>

							</div>
							<div id="statusUpdateFormDiv" style="display: none;"
								title="Manage Timeline">
								<input id="updateTimelineEventId" type="hidden" value="" />
								<table align="center" cellpadding="5">
									<tr>
										<td align="right"><span class='appFieldLabel'
											style="text-align: center; padding: 4px"><label
												id='statusIdLbl' name='statusIdLbl' for='statusId'>Status:<span
													class="invisibleRequiredFor508">*</span></label></span> <span
											class='requdIndicator'>*</span></td>
										<td><span style="padding: 4px"> <select
												name="statusId" id="statusId">
													<c:forEach items="${allStatusTypes}" var="status">
														<option value="${status.id}">
															<c:out value="${status.name}" />
														</option>
													</c:forEach>
											</select> <br> <span id='statusIdError' style="padding: 4px"></span>
										</span></td>
									</tr>
									<tr>
										<td nowrap align="right"><span class='appFieldLabel'
											style="padding: 4px"><label id='effectiveDateLbl'
												name='effectiveDateLbl' for='effectiveDate'>Effective
													Date:<span class="invisibleRequiredFor508">*</span>
											</label></span> <span class='requdIndicator'>*</span></td>
										<td><span style="padding: 4px"><input type='text'
												id='effectiveDate' name='effectiveDate'
												class='dateTimePicker' /></span><br> <span
											id='effectiveDateError' style="padding: 4px"></span></td>
									</tr>
									<tr>
										<td align="right"><span class='appFieldLabel'
											style="text-align: center; padding: 4px"><label
												id='statusChangeReasonLbl' name='statusChangeReasonLbl'
												for='statusChangeReason'>Status Reason:<span
													class="invisibleRequiredFor508">*</span></label></span> <span
											class='requdIndicator'>*</span></td>
										<td><select name="statusChangeReason"
											id="statusChangeReason">
												<option value="">Select a Reason...</option>
												<c:forEach items="${reasonList}" var="reason">
													<option value="${reason.code}">
														<c:out value="${reason.name}" />
													</option>
												</c:forEach>
										</select> <br /> <span id='statusChangeReasonError'
											style="padding: 4px"></span></td>
									</tr>
									<tr><td colspan="2" id='warning' align="center"></td></tr>
								</table>
							</div>
						</td>
					</tr>
				</table>
			</fieldset>
		</td>
	</tr>
</table>
