package gov.va.vss;

import javax.security.auth.login.LoginContext;

import org.springframework.batch.core.explore.JobExplorer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;

import gov.va.shared.model.core.IdentifiedPersistent;
import gov.va.shared.persistence.lookup.sds.StateDAO;
import gov.va.shared.test.AbstractTransactionalDAOTest;
import gov.va.vss.config.AppConfig;
import gov.va.vss.config.testOnly.AppTestConfig;
import gov.va.vss.persistence.dao.NationalOfficialDAO;
import gov.va.vss.persistence.dao.OrganizationDAO;
import gov.va.vss.persistence.dao.VistaStationDataDAO;
import gov.va.vss.persistence.dao.VoluntaryServiceStaffDAO;
import gov.va.vss.persistence.dao.VtkUserDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultDAO;
import gov.va.vss.persistence.dao.jobExecution.JobExecutionResultItemDAO;
import gov.va.vss.persistence.dao.lookup.ActiveStatusDAO;
import gov.va.vss.persistence.dao.lookup.JobExecutionTypeDAO;
import gov.va.vss.persistence.dao.lookup.StdVAVSTitleDAO;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionDAO;
import gov.va.vss.persistence.dao.lookup.VtkInstitutionTypeDAO;
import gov.va.vss.persistence.dao.lookup.VtkOrganizationTypeDAO;
import gov.va.vss.persistence.dao.lookup.VtkStateDAO;
import gov.va.vss.persistence.dao.views.FacilityAndVisnDAO;
import gov.va.vss.service.VistaStationDataService;
import gov.va.vss.service.VtkService;
import gov.va.vss.test.util.TestObjectFactory;

@ContextConfiguration(classes = { AppConfig.class, AppTestConfig.class })
public abstract class AbstractTransactionalWebDAOTest<T extends IdentifiedPersistent>
		extends AbstractTransactionalDAOTest<T> {

	protected LoginContext vistaLoginContext = null;

	@Autowired
	protected ActiveStatusDAO activeStatusDAO;
	@Autowired
	protected FacilityAndVisnDAO facilityAndVISNDAO;
	@Autowired
	protected JobExecutionResultDAO jobExecutionResultDAO;
	@Autowired
	protected JobExecutionResultItemDAO jobExecutionResultItemDAO;
	@Autowired
	protected JobExecutionTypeDAO jobExecutionTypeDAO;
	@Autowired
	protected NationalOfficialDAO nationalOfficalDAO;
	@Autowired
	protected OrganizationDAO organizationDAO;
	@Autowired
	protected StateDAO stateDAO;
	@Autowired
	protected StdVAVSTitleDAO stdVAVSTitleDAO;
	@Autowired
	protected VistaStationDataDAO vistaStationDataDAO;
	@Autowired
	protected VoluntaryServiceStaffDAO voluntaryServiceStaffDAO;
	@Autowired
	protected VtkInstitutionDAO vtkInstitutionDAO;
	@Autowired
	protected VtkInstitutionTypeDAO vtkInstitutionTypeDAO;
	@Autowired
	protected VtkOrganizationTypeDAO vtkOrganizationTypeDAO;
	@Autowired
	protected VtkStateDAO vtkStateDAO;
	@Autowired
	protected VtkUserDAO vtkUserDAO;
	@Autowired
	protected VistaStationDataService vistaStationDataService;
	@Autowired
	protected VtkService vtkService;

	@Autowired
	protected JobExplorer jobExplorer;

	@Autowired
	protected TestObjectFactory testObjectFactory;

}
