package gov.va.vss.model.views;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;
import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.PUBLIC_ONLY;

import javax.persistence.Entity;
import javax.persistence.Table;

import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.hibernate.annotations.Immutable;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

import gov.va.vss.model.lookup.AbstractBasicInstitution;

@Entity
@Immutable
// leaving this class as an example of a View, uncomment this if used later -
// CPB
// @Cache(usage = CacheConcurrencyStrategy.READ_ONLY)
@Table(name = "CombinedInstitutions", schema = "dbo")
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = PUBLIC_ONLY, isGetterVisibility = PUBLIC_ONLY)
public class CombinedInstitution extends AbstractBasicInstitution<CombinedInstitution> {
	private static final long serialVersionUID = 3254887002195956807L;

	// --------------------------------------------- Fields

	// ---------------------------------------- Common Methods

	@Override
	protected int requiredHashCode() {
		return new HashCodeBuilder().append(getId()).toHashCode();
	}

	@Override
	protected boolean requiredEquals(CombinedInstitution o) {
		return new EqualsBuilder().append(getId(), o.getId()).isEquals();
	}

	// --------------------------------------------- Accessor Methods

}
