package gov.va.vss.persistence.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.Query;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Repository;

import gov.va.vss.model.Donor;
import gov.va.vss.persistence.dao.DonorDAO;
import gov.va.vss.persistence.queryCustomization.QueryCustomization;

@Repository
public class DonorDAOImpl extends GenericHibernateSortedDAOImpl<Donor> implements DonorDAO {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(DonorDAOImpl.class);

	@Value("${donorSearch.maxResults}")
	private int maxResults;
	
	@SuppressWarnings("unchecked")
	@Override
	public List<Donor> findByCriteria(String firstName, String middleName, String lastName, String email) {
/*		if (!includeLocalFacility && !includeNational)
			return new ArrayList<>();

		if (includeLocalFacility && localFacilityIds == null)
			throw new IllegalArgumentException(
					"Parameter 'localFacilityIds' is required if includeLocalFacility is true");

		StringBuilder sb = new StringBuilder("select o from ").append(Organization.class.getName()).append(" o");
		sb.append(" left join o.vtkInstitution.vaFacility f");

		QueryCustomization cust = ArrayUtils.isEmpty(customization) ? new QueryCustomization() : customization[0];
		cust.appendRemainingJoins(sb, "o");

		if (cust.getOrderBy() == null)
			cust.setOrderBy("o.scope desc, f.stationNumber, o.name");

		List<String> whereClauseItems = new ArrayList<>();
		Map<String, Object> params = new HashMap<>();

		if (StringUtils.isNotBlank(name)) {
			whereClauseItems.add("LOWER(o.name) like :name1");
			params.put("name1", "%" + name.toLowerCase() + "%");
		}

		List<OrganizationScopeType> validScopeTypes = new ArrayList<>();
		if (includeLocalFacility) {
			validScopeTypes.add(OrganizationScopeType.LOCAL);

			whereClauseItems.add("o.scope <> :localScope or COALESCE(f.id, -1) in ( :localFacilityIds )");
			params.put("localScope", OrganizationScopeType.LOCAL);
			params.put("localFacilityIds", localFacilityIds);
		}

		if (includeNational)
			validScopeTypes.add(OrganizationScopeType.NATIONAL);

		whereClauseItems.add("o.scope in (:validScopes)");
		params.put("validScopes", validScopeTypes);

		Query q = constructQuery(em, sb, whereClauseItems, params, null, cust);

		return q.getResultList();*/
		
		
		
		StringBuilder sb = new StringBuilder("select v from ").append(Donor.class.getName()).append(" v");

		/*if (hasFacilityIds || hasFacilitySta3ns || hasInstitutionIds) {
			sb.append(" join v.volunteerFacilityAssignments vfa");
			sb.append(" join vfa.facilityAssignment fa");
		}*/

		/* Don't bother with this yet - CPB */
		QueryCustomization cust = new QueryCustomization();

		List<String> whereClauseItems = new ArrayList<>();
		Map<String, Object> params = new HashMap<>();

		if (StringUtils.isNotBlank(firstName)) {
			whereClauseItems.add("LOWER(v.firstName) like :firstName");
			params.put("firstName", "%" + firstName.toLowerCase() + "%");
		}
		
		if (StringUtils.isNotBlank(middleName)) {
			whereClauseItems.add("LOWER(v.middleName) like :middleName");
			params.put("middleName", "%" + middleName.toLowerCase() + "%");
		}

		if (StringUtils.isNotBlank(lastName)) {
			whereClauseItems.add("LOWER(v.lastName) like :lastName");
			params.put("lastName", "%" + lastName.toLowerCase() + "%");
		}

		/*if (StringUtils.isNotBlank(code)) {
			whereClauseItems.add("LOWER(v.identifyingCode) like :identifyingCode");
			params.put("identifyingCode", "%" + code.toLowerCase() + "%");
		}

		if (dateOfBirth != null) {
			whereClauseItems.add("v.dateOfBirth = :dob");
			params.put("dob", dateOfBirth);
		}

		if (hasFacilitySta3ns) {
			whereClauseItems.add("fa.facility.stationNumber in (:vaFacilitySta3ns)");
			params.put("vaFacilitySta3ns", vaFacilitySta3ns);
		}

		if (hasInstitutionIds) {
			whereClauseItems.add("fa.facility.id in (:vtkInstitutionIds)");
			params.put("vtkInstitutionIds", vtkInstitutionIds);
		}

		if (hasFacilityIds) {
			whereClauseItems.add("fa.facility.vaFacility.id in (:vaFacilityIds)");
			params.put("vaFacilityIds", vaFacilityIds);
		}

		if (StringUtils.isNotBlank(addressStreet)) {
			whereClauseItems
					.add("LOWER(v.addressLine1) like :addressStreet" + " or LOWER(v.addressLine2) like :addressStreet");
			params.put("addressStreet", "%" + addressStreet.toLowerCase() + "%");
		}

		if (StringUtils.isNotBlank(city)) {
			whereClauseItems.add("LOWER(v.city) like :city");
			params.put("city", "%" + city.toLowerCase() + "%");
		}

		if (activeStatus != null) {
			whereClauseItems.add("v.terminationDate is " + (activeStatus ? "" : "not") + " null");
		}*/

		/*
		 * Match on State abbreviation if specified value has only two letters;
		 * otherwise, wildcard match on state name
		 */
		/*if (StringUtils.isNotBlank(state)) {
			state = state.trim();
			if (state.trim().length() == 2) {
				whereClauseItems.add("LOWER(v.state.abbreviation) = :state");
				params.put("state", state.toLowerCase());
			} else {
				whereClauseItems.add("LOWER(v.state.name) like :state");
				params.put("state", "%" + state.toLowerCase() + "%");
			}
		}*/

		/* Match only on the first five digits */
		/*if (StringUtils.isNotBlank(zip)) {
			whereClauseItems.add("SUBSTRING(v.zip, 1, 5) = :zip");
			if (zip.length() > 5)
				zip = zip.substring(0, 5);
			params.put("zip", zip);
		}

		if (StringUtils.isNotBlank(phone)) {
			StringBuilder sb2 = new StringBuilder();
			for (String phoneField : new String[] { "phone", "phoneAlt", "phoneAlt2" })
				sb2.append(sb.length() > 0 ? " OR " : "") //
						.append("CONCAT(SUBSTRING(v.").append(phoneField).append(",1,3), ") //
						.append("SUBSTRING(v.").append(phoneField).append(", 5,3), ") //
						.append("SUBSTRING(v.").append(phoneField).append(", 10,4)) like :phone");
			whereClauseItems.add(sb2.toString());
			params.put("phone", "%" + phone.replaceAll("\\D", "") + "%");
		}*/

		if (StringUtils.isNotBlank(email)) {
			whereClauseItems.add("LOWER(v.email) like :email");
			params.put("email", "%" + email.toLowerCase() + "%");
		}

		Query q = constructQuery(em, sb, whereClauseItems, params, null, cust);

		int maxResults = this.maxResults;
		if (cust.getRowLimitation() != null)
			maxResults = cust.getRowLimitation();

		List<Donor> resultList = q.setMaxResults(maxResults).getResultList();
		return resultList;
	}

}
