package gov.va.vss.persistence.impl.lookup;

import java.util.List;

import org.springframework.stereotype.Repository;

import gov.va.vss.model.lookup.VtkAdministrativeUnit;
import gov.va.vss.model.lookup.VtkInstitution;
import gov.va.vss.persistence.dao.lookup.VtkAdministrativeUnitDAO;
import gov.va.vss.persistence.impl.GenericHibernateSortedDAOImpl;

@Repository
public class VtkAdministrativeUnitDAOImpl extends GenericHibernateSortedDAOImpl<VtkAdministrativeUnit>
		implements VtkAdministrativeUnitDAO {

	public VtkInstitution findByStationNumber(String stationNumber) {
		@SuppressWarnings("unchecked")
		List<VtkInstitution> results = query(
				"from " + VtkInstitution.class.getName() + " where stationNumber = :stationNumber")
						.setParameter("stationNumber", stationNumber).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

	@Override
	public VtkAdministrativeUnit findBySDSInstitution(long vaFacilityId) {
		@SuppressWarnings("unchecked")
		List<VtkAdministrativeUnit> results = query(
				"from " + VtkAdministrativeUnit.class.getName() + " where visnFacility.id = :vaFacilityId")
						.setParameter("vaFacilityId", vaFacilityId).getResultList();
		return results.isEmpty() ? null : results.get(0);
	}

}
