package gov.va.vss.persistence.impl.views;

import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Repository;

import gov.va.vss.model.views.CombinedInstitution;
import gov.va.vss.persistence.dao.views.CombinedInstitutionDAO;
import gov.va.vss.persistence.impl.GenericHibernateSortedDAOImpl;

@Repository
public class CombinedInstitutionDAOImpl extends GenericHibernateSortedDAOImpl<CombinedInstitution>
		implements CombinedInstitutionDAO {
	@SuppressWarnings("unused")
	private static final Logger log = LoggerFactory.getLogger(CombinedInstitutionDAOImpl.class);

	@Override
	public SortedSet<CombinedInstitution> findWithLinkToVAFacility() {
		@SuppressWarnings("unchecked")
		List<CombinedInstitution> results = query(
				"select i from " + CombinedInstitution.class.getName() + " i where vaFacility is not null")
						.getResultList();
		return new TreeSet<>(results);
	}

}
