package gov.va.vss.service;

import gov.va.vss.model.VtkUser;
import gov.va.vss.service.validation.ServiceValidationException;

public interface VtkUserService {

	/**
	 * @param vtkUser
	 *            The vtkUser to save or update
	 * @return The updated vtkUser after it's been persisted / updated
	 * @throws ServiceValidationException
	 *             If a business-level validation exception occurred during the
	 *             save/update process
	 */
	VtkUser saveOrUpdate(VtkUser vtkUser) throws ServiceValidationException;

	/**
	 * Deletes the VtkUser with the specified vtkUserId
	 * 
	 * @param vtkUserId
	 *            The ID of the vtkUser to delete
	 */
	int delete(long vtkUserId);

	int deleteByAppUserId(long appUserId);

	VtkUser createOrRetrieveVtkUser(String username);

	AppUserAndVtkUser createOrRetrieveAppUser(String username);

}
