function onPageLoad(isNew, isReadOnly, anyTerminationFieldsSet, volunteerId) {
	if (isReadOnly)
		setPageTitle('View Volunteer')
	
	var showDeleteAction = true
	/*
	 * sec:authorize access="hasAuthority('${PERMISSION_VOL_SVC_STAFF_DELETE}')"
	 * showDeleteAction = !isReadOnly / sec:authorize
	 */
	
	$('.dateInput').each(function() {
		$(this).enableDatePicker({
			showOn : "button",
			buttonImage : imgHome + "/calendar.gif",
			buttonImageOnly : true
		})
		$(this).mask(twoDigitDateMask)
	})
	
	var defaultParms = {
		"paging" : false,
		"processing" : true,
		"scrollCollapse" : true,
    	"scrollY" : "110px"
	}
	
	var orgCols = [{
		"targets" : 0,
		"data" : function(row, type, val, meta) {
			return row.organization.displayName
		}
	}, {
		"targets" : 1,
		"data" : function(row, type, val, meta) {
			return row.active ? 'Active' : 'Inactive'
		}
	}]
	
	if (!isReadOnly) {
		orgCols[orgCols.length] = {
			"targets" : 2,
			"data" : function(row, type, val, meta) {
				var actions = '<div style="margin:0 auto; text-align:center">'
				
				if (showDeleteAction)
					actions += '<a href="javascript:inactivateOrganization('
							+ row.id + ')"><img src="'+ imgHome
							+ '/delete.gif" border="0" hspace="5" align="center"/></a>'
				actions += '</div>'
				return actions;
			}
		}
	}
	
	$('#organizationsTable').DataTable($.extend({}, defaultParms, {
		"columnDefs" : orgCols,
    	"dom": '<"top">rt<"bottom"l>',
    	"language" : {
			zeroRecords : "No Organizations",
			searchPlaceholder : "Search by name..."
		}
	}))
	
	var assignmentCols = [ {
		"targets" : 0,
		"data" : function(row, type, val, meta) {
			if (type === 'filter') {
				return abbreviate(row.facilityAssignment.benefitingService.displayName, 25)
			}
			return row.facilityAssignment.benefitingService.displayName
		}
	}, {
		"targets" : 1,
		"data" : function(row, type, val, meta) {
			if (type === 'filter') {
				return abbreviate(row.facilityAssignment.facility.displayName, 25)
			}
			return row.facilityAssignment.facility.displayName
		}
	}]
	
	if (!isReadOnly) {
		assignmentCols[assignmentCols.length] = {
			"targets" : 2,
			"data" : function(row, type, val, meta) {
				var actions = '<div style="margin:0 auto; text-align:center">'
				
				if (showDeleteAction)
					actions += '<a href="javascript:deleteAssignment('
							+ row.id + ')"><img src="'+ imgHome
							+ '/delete.gif" border="0" hspace="5" align="center"/></a>'
				actions += '</div>'
				return actions;
			}
		}
	}
	
	$('#assignmentsTable').DataTable($.extend({}, defaultParms, {
		"columnDefs" : assignmentCols,
    	"dom": '<"top">rt<"bottom"l>',
    	"language" : {
			zeroRecords : "No Assignments",
			infoEmpty: "No assignments available",
			searchPlaceholder : "Search by name..."
		}
	}))
	
	if (!isNew) {
		var parkingCols = [ { // facility, sticker, license, expires
			"targets" : 0,
			"data" : function(row, type, val, meta) {
				return row.facility ? row.facility.displayName : ''
			}
		}, {
			"targets" : 1,
			"data" : function(row, type, val, meta) {
				return row.stickerNumber
			}
		}, {
			"targets" : 2,
			"data" : function(row, type, val, meta) {
				return (row.state ? row.state.displayName : "") + " ["  + row.licensePlate + "]"
				
			}
		}]
		
		if (!isReadOnly) {
			parkingCols[parkingCols.length] = {
				"targets" : 3,
				"data" : function(row, type, val, meta) {
					var actions = '<div style="margin:0 auto; text-align:center">'
					
					if (showDeleteAction)
						actions += '<a href="javascript:deleteParkingSticker('
								+ row.id + ')"><img src="'+ imgHome
								+ '/delete.gif" border="0" hspace="5" align="center"/></a>'
					actions += '</div>'
					return actions
				}
			}
		}
		
		$('#parkingStickersTable').DataTable($.extend({}, defaultParms, {
			"columnDefs" : parkingCols,
	    	"dom": '<"top">rt<"bottom"l>',
	    	"language" : {
				zeroRecords : "No parking stickers available",
				infoEmpty: "No parking stickers available",
				searchPlaceholder : "Search by name..."
			}
		}))
		
		// ------------------------------- Uniforms
		
		var uniformCols = [ { // shirt size, uniform, number of shirts
			"targets" : 0,
			"data" : function(row, type, val, meta) {
				return row.shirtSize ? row.shirtSize.name : ''
			}
		}, {
			"targets" : 1,
			"data" : function(row, type, val, meta) {
				return row.uniform
			}
		}, {
			"targets" : 2,
			"data" : function(row, type, val, meta) {
				return row.numberOfShirts
				
			}
		}]
		
		if (!isReadOnly) {
			uniformCols[uniformCols.length] = {
				"targets" : 3,
				"data" : function(row, type, val, meta) {
					var actions = '<div style="margin:0 auto; text-align:center">'
					
					if (showDeleteAction)
						actions += '<a href="javascript:deleteUniform('
								+ row.id + ')"><img src="'+ imgHome
								+ '/delete.gif" border="0" hspace="5" align="center"/></a>'
					actions += '</div>'
					return actions
				}
			}
		}
		
		$('#uniformsTable').DataTable($.extend({}, defaultParms, {
			"columnDefs" : uniformCols,
	    	"dom": '<"top">rt<"bottom"l>',
	    	"language" : {
				zeroRecords : "No Uniforms",
				infoEmpty: "No uniforms available",
				searchPlaceholder : "Search..."
			}
		}))
	}
	
	$('.terminatedFields').toggle(anyTerminationFieldsSet)
	$('.notTerminatedFields').toggle(!anyTerminationFieldsSet)
	
	if (isNew) {
		editName()
	} else {
		refreshOrganizations(volunteerId)
		refreshAssignments(volunteerId)
		refreshParkingStickers(volunteerId)
		refreshUniforms(volunteerId)
	}
	
	var mealRemarksUpdated = function() {
		var theVal = $("#mealsEligibleInput").val()
		var show = $.trim(theVal) == '0'
		// temporary until we get feedback - CPB
		$(".mealRemarksFields").toggle(true)
		var theTextarea = $("#mealRemarks")
		theTextarea.attr('placeholder', show ? '*[Meal remarks - required]' : '[Meal remarks]')
		theTextarea.removeClass("placeholderRequired")
		if (show)
			theTextarea.addClass("placeholderRequired")
		// $(".mealRemarksTitle").css('display', show ? 'inline-block' : 'none')
		
	}
	$("#mealsEligibleInput").change(mealRemarksUpdated)
	mealRemarksUpdated()
	
	var terminatedWithCauseUpdated = function() {
		var isChecked = $("#terminatedWithCauseCheckbox").is(":checked")
		
		$("#terminationDateRequired").toggle(isChecked)
		
		var theTextarea = $("#terminationRemarks")
		theTextarea.attr('placeholder', isChecked ? '*[Termination remarks - required]' : '[Termination remarks]')
		theTextarea.removeClass("placeholderRequired")
		if (isChecked)
			theTextarea.addClass("placeholderRequired")
	}
	$("#terminatedWithCauseCheckbox").change(terminatedWithCauseUpdated)
	terminatedWithCauseUpdated()
	
	$("#awardSelect").change(function() {
		$("#lastAwardHours").val(awardHoursMap[$(this).val()])
		if ($(this).val() == '')
			$("#dateOfLastAwardInput").val('')
	})
	
	if (!isNew) {
		$("#primaryOrganization").change(function() {
			setPrimaryOrganization(volunteerId, $(this).val())
		})
		
		$("#primaryFacility").change(function() {
			setPrimaryFacility(volunteerId, $(this).val())
		})
	}
}

function editName() {
	$(".fixedNameFields").hide()
	$(".nameInputs").show()
}

function terminateVolunteer() {
	$('.terminatedFields').show()
	$('.notTerminatedFields').hide()
}

function refreshOrganizations(volunteerId) {
	$.ajax({
		url : ajaxHomePath + '/volunteerOrganizations',
		dataType : 'json',
		data : {
			volunteerId: volunteerId
		},
		error : commonAjaxErrorHandler,
		success : function(r) {
			redrawWithRows('organizationsTable', r.organizations)
			$("#organizationsTable_filter1").val('Active')
			$("#organizationsTable_filter1").change()
			
			var uniqueOrganizations = new SortedArray([])
			var organizations = []
			$(r.organizations).each(function(index, item) {
				if (uniqueOrganizations.search(item.organization.id) != -1)
					return
				if (item.active) {
					organizations.push({
						id: item.organization.id,
						name: item.organization.displayName
					})
					uniqueOrganizations.insert(item.organization.id)
				}
			})
			if (r.primaryOrganization && uniqueOrganizations.search(r.primaryOrganization.id) == -1) {
				organizations.push({
					id: r.primaryOrganization.id,
					name: r.primaryOrganization.displayName
				})
			}
			
			var orgSelect = $('#primaryOrganization')
			var orgsAvail = organizations.length > 0
			orgSelect.toggle(orgsAvail)
			$('#noOrganizationsAvailable').toggle(!orgsAvail)
			orgSelect.empty()
			
			$(organizations).each(function(index, item) {
				orgSelect.append($('<option>', {
					value : item.id,
					text : item.name,
					selected : r.primaryOrganization && item.id == r.primaryOrganization.id
				}))
			})
		}
	})
}

function setPrimaryOrganization(volunteerId, organizationId) {
	$.ajax({
		url : ajaxHomePath + "/volunteer/setPrimaryOrganization",
		type : "POST",
		dataType : 'json',
		data : {
			volunteerId : volunteerId,
			organizationId : organizationId
		},
		error : commonAjaxErrorHandler,
		success : function(result) {
			displayAttentionDialog('The primary organization was updated successfully.')
			$("#primaryOrganization").val(organizationId)
		}
	})
}

function setPrimaryFacility(volunteerId, facilityId) {
	$.ajax({
		url : ajaxHomePath + "/volunteer/setPrimaryFacility",
		type : "POST",
		dataType : 'json',
		data : {
			volunteerId : volunteerId,
			facilityId : facilityId
		},
		error : commonAjaxErrorHandler,
		success : function(result) {
			displayAttentionDialog('The primary facility was updated successfully.')
			$("#primaryFacility").val(facilityId)
		}
	})
}

function refreshAssignments(volunteerId) {
	$.ajax({
		url : ajaxHomePath + '/volunteerAssignments',
		dataType : 'json',
		data : {
			volunteerId: volunteerId
		},
		error : commonAjaxErrorHandler,
		success : function(r) {
			redrawWithRows('assignmentsTable', r.assignments)
			
			var uniqueFacilities = new SortedArray([])
			var facilities = []
			if (r.primaryFacility) {
				facilities.push({
					id: r.primaryFacility.id,
					name: r.primaryFacility.displayName
				})
				uniqueFacilities.insert(r.primaryFacility.id)
			}
			$(r.assignments).each(function(index, item) {
				if (uniqueFacilities.search(item.facilityAssignment.facility.id) != -1)
					return
					
				facilities.push({
					id: item.facilityAssignment.facility.id,
					name: item.facilityAssignment.facility.displayName
				})
				uniqueFacilities.insert(item.facilityAssignment.facility.id)
			})
			
			var facSelect = $('#primaryFacility')
			var facilitiesAvail = facilities.length > 0
			facSelect.toggle(facilitiesAvail)
			$('#noFacilitiesAvailable').toggle(!facilitiesAvail)
			facSelect.empty()
			
			if (!r.primaryFacility) {
				facSelect.append($('<option>', {
					value : '',
					text : '(Unknown)',
					selected : true
				}))
			}
			
			$(facilities).each(function(index, item) {
				facSelect.append($('<option>', {
					value : item.id,
					text : item.name,
					selected : r.primaryFacility && item.id == r.primaryFacility.id
				}))
			})
		}
	})
}

function refreshParkingStickers(volunteerId) {
	$.ajax({
		url : ajaxHomePath + '/volunteerParkingStickers',
		dataType : 'json',
		data : {
			volunteerId: volunteerId
		},
		error : commonAjaxErrorHandler,
		success : function(r) {
			redrawWithRows('parkingStickersTable', r)
		}
	})
}

function refreshUniforms(volunteerId) {
	$.ajax({
		url : ajaxHomePath + '/volunteerUniforms',
		dataType : 'json',
		data : {
			volunteerId: volunteerId
		},
		error : commonAjaxErrorHandler,
		success : function(r) {
			redrawWithRows('uniformsTable', r)
		}
	})
}

function redrawWithRows(tableId, rows) {
	var table = $('#' + tableId).DataTable()
	table.clear()
	table.rows.add(rows)
	rebuildTableFilters(tableId)
	table.draw()
}

function toggleFields(className, val) {
	$('.' + className).toggle(val)
	$('#show_' + className).toggle(!val)
	$('#hide_' + className).toggle(val)
}

function submitForm(isEdit) {
	doubleClickSafeguard($("#submitButton"))
	
	var firstName = $("#firstNameInput").val()
	var lastName = $("#lastNameInput").val()
	if ($.trim(firstName) == '' || $.trim(lastName) == '') {
		displayAttentionDialog('Please enter both first name and last name.')
		return false
	}
	
	var dobVal = $.trim($("#dateOfBirthInput").val())
	if (dobVal == '' || !validateDate(dobVal)) {
		displayAttentionDialog('Please enter a valid date of birth.')
		return false
	}
	
	if (isEdit) return true
	
	if (firstName == commandFirstName && lastName == commandLastName
			&& removeChars(dobVal, ['-', '/']) == getAsMMDDYYYY(commandDob))
		return true
	
	$("#submitButton").val('Checking duplicates...')
	$("#submitButton").prop('disabled', true)
	
	$.ajax({
		url : ajaxHomePath + '/volunteerDuplicateCheck',
		dataType : 'json',
		data : {
			firstName: $("#firstNameInput").val(),
			lastName: $("#lastNameInput").val(),
			dob: $("#dateOfBirthInput").val()
		},
		error : commonAjaxErrorHandler,
		success : function(r) {
			if (r.length == 0) {
				$("#submitButton").val('Submitting form...')
				finalSubmit()
				return
			}
			
			$("#submitButton").val('Create')
			$("#submitButton").prop('disabled', false)				
			popupVolunteerSearch('volProfCheckForDups', r)
		}
	})
	
	return false
}

function finalSubmit() {
	$("#volunteerForm")[0].submit()
}