package gov.va.vss.model.facility;

import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.NONE;
import static com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility.PUBLIC_ONLY;

import javax.persistence.DiscriminatorColumn;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.Table;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

import com.fasterxml.jackson.annotation.JsonAutoDetect;

import gov.va.shared.model.lookup.sds.State;

@Entity
@Inheritance
@Table(name = "VtkInstitutions_tbl", schema = "dbo")
@DiscriminatorColumn(name = "Type")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
@JsonAutoDetect(fieldVisibility = NONE, getterVisibility = PUBLIC_ONLY, isGetterVisibility = PUBLIC_ONLY)
public abstract class AbstractUpdateableLocation<T extends AbstractUpdateableLocation<T>> extends AbstractLocation {
	private static final long serialVersionUID = 3810180355498406255L;

	// ---------------------------------------- Constructors

	protected AbstractUpdateableLocation() {
	}

	protected AbstractUpdateableLocation(String name, String addressLine1, String addressLine2, String city,
			State state, String zip, AbstractUpdateableLocation<?> parent) {
		super(name, addressLine1, addressLine2, city, state, zip, parent);
	}

}
