package gov.va.vss.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import gov.va.vss.model.DonationDetail;
import gov.va.vss.model.DonationSummary;
import gov.va.vss.service.DonationService;

@Service
public class DonationServiceImpl extends AbstractServiceImpl implements DonationService {
	private static final Logger log = LoggerFactory.getLogger(DonationServiceImpl.class);

	public DonationDetail saveOrUpdateDonationDetail(DonationDetail donationDetail) {
		return donationDetailDAO.saveOrUpdate(donationDetail);
	}

	public DonationSummary saveOrUpdateDonationSummary(DonationSummary donationSummary) {
		return donationSummaryDAO.saveOrUpdate(donationSummary);
	}

	public void deleteDonationDetail(long donationDetailId) {
		donationDetailDAO.delete(donationDetailId);
	}

	public void deleteDonationSummary(long donationSummaryId) {
		donationSummaryDAO.delete(donationSummaryId);
	}
}
