package gov.va.vss.service.impl;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import gov.va.vss.model.facility.Facility;
import gov.va.vss.service.FacilityService;
import gov.va.vss.service.validation.ServiceValidationException;

@Service
public class FacilityServiceImpl extends AbstractServiceImpl implements FacilityService {
	private static final Logger log = LoggerFactory.getLogger(FacilityServiceImpl.class);

	@Override
	public Facility saveOrUpdate(Facility facility) throws ServiceValidationException {
		/* Business-level validations */

		facility = facilityDAO.saveOrUpdate(facility);
		return facility;
	}

	@Override
	public void delete(long facilityId) {
		facilityDAO.delete(facilityId);
	}

	@Override
	public void unlinkSDSFacilityFromFacility(long facilityId) {
		facilityDAO.updateFieldsWithoutVersionIncrement(facilityId, true, null);
	}

	@Override
	public void linkSDSFacilityToFacility(long facilityId, long vaFacilityId) {
		facilityDAO.updateFieldsWithoutVersionIncrement(facilityId, true, vaFacilityId);
	}

}
