package gov.va.vss.service.impl;

import java.util.Map;
import java.util.SortedSet;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import gov.va.shared.model.AppUser;
import gov.va.shared.model.lookup.sds.VAFacility;
import gov.va.shared.service.UserAdminCustomizations;
import gov.va.vss.model.VtkUser;
import gov.va.vss.service.VtkUserService;

@Component
public class VtkUserAppUserCallback extends AbstractServiceImpl implements UserAdminCustomizations {

	@Autowired
	private VtkUserService vtkUserService;

	@Override
	public AppUser userRetrievedCallback(AppUser u, Map<String, Object> userAdminCustomizationsModel) {
		VtkUser vtkUser = vtkUserService.createOrRetrieveVtkUser(u.getUsername());
		if (userAdminCustomizationsModel != null)
			userAdminCustomizationsModel.put("vtkUser", vtkUser);

		return u;
	}

	@Override
	public AppUser userCreatedCallback(AppUser u, Map<String, Object> userAdminCustomizationsModel) {
		VtkUser vtkUser = vtkUserService.createOrRetrieveVtkUser(u.getUsername());
		if (userAdminCustomizationsModel != null)
			userAdminCustomizationsModel.put("vtkUser", vtkUser);

		return u;
	}

	@Override
	public SortedSet<VAFacility> getAssignableFacilities() {
		return facilityDAO.findVAFacilitiesWithLinkToFacility();
	}

	@Override
	public void userDeletedCallback(long appUserId, Map<String, Object> userAdminCustomizationsModel) {
		int numDeleted = vtkUserService.deleteByAppUserId(appUserId);
		if (userAdminCustomizationsModel != null)
			userAdminCustomizationsModel.put("numDeleted", numDeleted);
	}

}
