<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">

	$(function() {
		$("#donationDetailsDialog").dialog({
			autoOpen : false,
			modal : true,
			width : 500,
			height : 300,
			closeOnEscape : false,
			draggable : true,
			resizable : true,
			buttons : {
				'Submit' : {
					text : 'Submit',
					id : 'donationDetailDialogSubmitBtn',
					click : submitDonationDetails
				},
				//'Submit' : submitStaffDetails,
				'Cancel' : function() {
					$(this).dialog('close')
				},
			}
		})

		$("#donationDetailsDialog").show()
		/*
		 * Required to solve 508 issue not reading dialog box title. It is also
		 * required to disable dialog animation to enable this functionality
		 */
		$('#donationDetailsDialog').focus()
		
		refreshDonationDetails()
	})

	var donationDetailsList = new Object()

	function showDonationDetailsPopup(donationDetailId) {
		var hasDonationDetailId = (typeof donationDetailId !== 'undefined')
		$("#donationDetailsDialog").data('donationDetailId', hasDonationDetailId ? donationDetailId : '')

		if (hasDonationDetailId) {
			var fullObj = donationDetailsList[donationDetailId]
			$("#generalPostFund").val(
					fullObj.donGenPostFund ? fullObj.donGenPostFund.id : '')
			$("#donationValue").val(fullObj.donationValue)
		}

		if (!hasDonationDetailId) {
			$("#generalPostFund").val('')
			$("#donationValue").val('')
		}
	
		$("#donationDetailsDialog").dialog('open')
	}

	var hasDonationDetailWithRealGPF = false
	
	function refreshDonationDetails() {
		var myDonationSumId = ${command.donationSummary.id}
		
		$.ajax({
					url : ajaxHomePath + '/donationDetails',
					dataType : 'json',
					data : {
						donationSummaryId : myDonationSumId? myDonationSumId: ${0}
					},
					error : commonAjaxErrorHandler,
					success : function(response) {
						var rArray = new Array()
						var curDate = new Date()
						
						var totalValue = 0
						
						for (var i = 0; i < response.length; i++) {
							if (response[i].donGenPostFund.generalPostFund != "<c:out value="${GPF_NONE_VALUE}" />")
									hasDonationDetailWithRealGPF = true
							totalValue += response[i].donationValue;
							donationDetailsList[response[i].id] = response[i]
							rArray[rArray.length] = new Array(
									<c:if test="${not FORM_READ_ONLY}">
								     '<a href="javascript:showDonationDetailsPopup('
											+ response[i].id
											+ ')">'
											+ escapeHTML(response[i].donGenPostFund.generalPostFund)
											+ '</a>'
										</c:if>
										<c:if test="${FORM_READ_ONLY}">
										     escapeHTML(response[i].donGenPostFund.generalPostFund)
										</c:if>,								
									 escapeHTML('$'+ formatAndAddThousandSeparators(response[i].donationValue)),
									'<a href="javascript:deleteDonationDetail('
											+ response[i].id + ')"><img src="'+ imgHome
											+ '/permanently_delete_18x18.png" border="0" hspace="40" align="center"/></a>'	
								)
						}
						
						$("#totalValueSpan").text(formatAndAddThousandSeparators(totalValue))
						
						$(".confirm").easyconfirm()
						
						refreshDonationDetailsData(rArray)
					}
				})
	}

	function submitDonationDetails() {
		var myGeneralPostFund = $("#generalPostFund").val()
		if (myGeneralPostFund == '') {
			displayAttentionDialog('General Post Fund is required.')
			return
		}
				
		if ($('#donationValue').val() == '') {
			displayAttentionDialog("Donation Amount is required.")
			return
		}
			
		if ($('#donationValue').val() > 9999999999.99 ) {
			displayAttentionDialog("The maximun donation amount is 9999999999.99.")
			return
		}
			
				
		if ($('#donationValue').val() != ''
			&& !validateNumericWithoutCommas($('#donationValue').val())) {
			displayAttentionDialog("Donation Amount is invalid [format should be ########## or ##########.##].") 
			return
		}
		
		if(($("#generalPostFund").val() != "NONE") &&  ($('#donationTypeSelect').val() == '3' || $('#donationTypeSelect').val() == '4')) {
			displayAttentionDialog("The general post fund must be NONE for donation type Item/Activity.")
			return
		}

		/* If validations pass, submit to server - CPB */
		$.ajax({
			url : ajaxHomePath + '/donationDetailCreateOrUpdate',
			method : 'POST',
			dataType : 'json',
			data : {
				donationSummaryId : '${command.donationSummary.id}', //TODO_SZ ???
				donationDetailId : $("#donationDetailsDialog").data(
						'donationDetailId'),
				generalPostFund : $("#generalPostFund").val(),
				donationValue : $("#donationValue").val(),
			},
			error : commonAjaxErrorHandler,
			success : function(response) {
				$("#donationDetailsDialog").dialog('close')
				/* generated by inc_jqueryTable.jsp, see below */
				
				
				refreshDonationDetails()
			}
		})
	}
</script>

<div id="donationDetailsDialog" style="display: none"
	title="Donation Detail">
	<input type="hidden" id="donationSummaryId" value="" />
	<div class="donationDetailInputFields donationDetailDisplay">
		<fieldset>

			<legend>Donation Detail</legend>
			<table>

				<tr>
					<td class='appFieldLabel' nowrap>General Post Fund:<span
						class="invisibleRequiredFor508">*</span></td>
					<td><span class='requdIndicator'>*</span></td>
					<td colspan="10"><select id="generalPostFund">
							<option value="">Please select...</option>
							<c:forEach items="${allDonGenPostFunds}" var="genPostFund">
								<option value="${genPostFund.id}"><c:out
										value="${genPostFund.generalPostFund}" /></option>
							</c:forEach>
					</select></td>
				</tr>

				<tr>
					<td class='appFieldLabel' nowrap>Donation Amount:<span
						class="invisibleRequiredFor508">*</span></td>
					<td><span class='requdIndicator'>*</span></td>
					<td><input type="text" id="donationValue" maxlength="13"
						class="currency" /></td>
				</tr>
			</table>
		</fieldset>
	</div>
</div>