<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript"
	src="${pkgHome}/accessible-dropdown-menu/accessible-dropdown-menu.js"></script>
<link type="text/css"
	href="${pkgHome}/accessible-dropdown-menu/accessible-dropdown-menu.css"
	rel="Stylesheet" />

<jsp:include page="/WEB-INF/jsp/shared/inc_volunteerSearchPopup.jsp">
	<jsp:param name="uniqueVolunteerSearchPopupId" value="menuSearch" />
	<jsp:param name="resultCallbackMethod"
		value="menuVolunteerSelectedCallback" />
</jsp:include>

<jsp:include page="/WEB-INF/jsp/shared/inc_volunteerSearchPopup.jsp">
	<jsp:param name="uniqueVolunteerSearchPopupId" value="menuAdd" />
	<jsp:param name="mode" value="add" />
	<jsp:param name="resultCallbackMethod"
		value="menuVolunteerSelectedCallback" />
	<jsp:param name="disclaimerText"
		value="Please search for an existing volunteer before adding a new one:" />
	<jsp:param name="addButtonCallbackMethod"
		value="menuVolunteerAddSelectedCallback" />
</jsp:include>

<jsp:include page="/WEB-INF/jsp/shared/inc_organizationSearchPopup.jsp">
	<jsp:param name="uniqueOrganizationSearchPopupId" value="menuSearch" />
	<jsp:param name="resultCallbackMethod"
		value="menuOrganizationSelectedCallback" />
	<jsp:param name="includeInactiveOption" value="true" />
	<jsp:param name="mode" value="search" />
</jsp:include>

<jsp:include page="/WEB-INF/jsp/shared/inc_donorSearchPopup.jsp">
	<jsp:param name="uniqueDonorSearchPopupId" value="menuSearch" />
	<jsp:param name="resultCallbackMethod"
		value="menuDonorSelectedCallback" />
</jsp:include>

<jsp:include page="/WEB-INF/jsp/shared/inc_donorSearchPopup.jsp">
	<jsp:param name="uniqueDonorSearchPopupId" value="menuAdd" />
	<jsp:param name="mode" value="add" />
	<jsp:param name="resultCallbackMethod"
		value="menuDonorSelectedCallback" />
	<jsp:param name="disclaimerText"
		value="Please search for an existing donor before adding a new one:" />
	<jsp:param name="addButtonCallbackMethod"
		value="menuDonorAddSelectedCallback" />
</jsp:include>


<div class='sidemenucontainer' role="application">
	<div class="sidebarmenu" role="navigation">

		<ul id="navigationMenuBar" role="menubar" title="VSS menu bar">

			<li id="appMenuHome" role="menuitem" aria-haspopup="false"
				tabIndex="-1"><a href="${home}" id="homeLink" title="Home"
				shortcut="Shift+h" class="hotkeyed" role="menuitem">Home</a></li>

			<c:if test="${not siteContext.centralOffice}">
				<sec:authorize
					access="hasAnyAuthority('${PERMISSION_VOLUNTEER_READ},
					${PERMISSION_VOLUNTEER_CREATE}')">
					<li role="menuitem" aria-haspopup="true"><a
						id="menuVolunteerLink" href="#" title="Volunteer"
						shortcut="Shift+v" class="hotkeyed" role="menuitem">Volunteers</a>
						<ul id="menuVolunteer" role="menu" style="width: 180px">
							<sec:authorize
								access="hasAuthority('${PERMISSION_VOLUNTEER_READ}')">
								<li role="menuitem"><a
									href="javascript:popupVolunteerSearch('menuSearch')"
									title="Search for Volunteer" shortcut="sv"
									class="sequencehotkeyed" role="menuitem">Search for
										Volunteer</a></li>
							</sec:authorize>
							<sec:authorize
								access="hasAuthority('${PERMISSION_VOLUNTEER_CREATE}')">
								<li role="menuitem"><a
									href="javascript:popupVolunteerSearch('menuAdd')"
									title="Create a Volunteer" shortcut="cv"
									class="sequencehotkeyed" role="menuitem">Create New
										Volunteer</a></li>
							</sec:authorize>
						</ul></li>
				</sec:authorize>
			</c:if>

			<c:if test="${not siteContext.centralOffice}">
				<sec:authorize
					access="hasAnyAuthority('${PERMISSION_DONATION_READ},
					${PERMISSION_DONATION_CREATE}')">
					<li role="menuitem" aria-haspopup="true"><a
						id="menuDonationLink" href="#" title="Donation" shortcut="Shift+d"
						class="hotkeyed" role="menuitem">Donations</a>
						<ul id="menuDonation" role="menu" style="width: 180px">
							<sec:authorize
								access="hasAuthority('${PERMISSION_DONATION_READ}')">
								<li role="menuitem"><a
									href="javascript:popupDonorSearch('menuSearch')"
									title="Search for Donor" shortcut="sd" class="sequencehotkeyed"
									role="menuitem">Search Donor</a></li>
							</sec:authorize>
							<sec:authorize
								access="hasAuthority('${PERMISSION_DONATION_CREATE}')">
								<li role="menuitem"><a
									href="javascript:popupDonorSearch('menuAdd')" title="Add Donor"
									shortcut="ad" class="sequencehotkeyed" role="menuitem">Add
										Donor</a></li>
							</sec:authorize>
						</ul></li>
				</sec:authorize>
			</c:if>

			<li role="menuitem" aria-haspopup="true"><a href="#"
				title="Reports" shortcut="Shift+o" class="hotkeyed" role="menuitem">Reports</a>
				<ul id="appMenuReports" role="menu" style="width: 270px">
					<c:if test="${showBackgroundJobLog}">
						<li role="menuitem"><a href="${backgroundJobUrl}"
							title="Background Job Log" shortcut="lo" class="sequencehotkeyed"
							role="menuitem">Background Job Log</a></li>
					</c:if>

					<li role="menuitem" aria-haspopup="true"><a href="#"
						title="Address Label Reports" shortcut="ar"
						class="sequencehotkeyed" role="menuitem">Address Label Reports</a>

						<ul id="addressLabelReportsList" role="menu">

							<%-- Volunteer Address Labels --%>
							<li role="menuitem"><a
								href="${home}/displayReportParameters.htm?reportCode=val"
								title="<fmt:message key="reports.val.displayName" />"
								shortcut="val" class="sequencehotkeyed" role="menuitem"><fmt:message
										key="reports.val.displayName" /></a></li>

							<%-- Voluntary Service Directory Labels --%>
							<li role="menuitem"><a
								href="${home}/displayReportParameters.htm?reportCode=vsdl"
								title="<fmt:message key="reports.vsdl.displayName" />"
								shortcut="vsdl" class="sequencehotkeyed" role="menuitem"><fmt:message
										key="reports.vsdl.displayName" /></a></li>

							<%-- National Officials Label --%>
							<li role="menuitem"><a
								href="${home}/displayReportParameters.htm?reportCode=nol"
								title="<fmt:message key="reports.nol.displayName" />"
								shortcut="nol" class="sequencehotkeyed" role="menuitem"><fmt:message
										key="reports.nol.displayName" /></a></li>
						</ul></li>

					<%-- Voluntary Service Directory --%>
					<li role="menuitem"><a
						href="${home}/displayReportParameters.htm?reportCode=vsd"
						title="<fmt:message key="reports.vsd.displayName" /> Report"
						shortcut="vsd" class="sequencehotkeyed" role="menuitem"><fmt:message
								key="reports.vsd.displayName" /></a></li>
					<li role="menuitem"><a href="${home}/letterTemplateEdit.htm"
						title="Edit Letter Templates" shortcut="elt"
						class="sequencehotkeyed" role="menuitem">Manage <c:if test="${siteContext.centralOffice}">Default</c:if> Letter
							Templates</a></li>
				</ul></li>

			<li role="menuitem" aria-haspopup="true"><a href="#"
				title="Administration" shortcut="Shift+d" class="hotkeyed"
				role="menuitem">Maintenance</a>
				<ul id="menuAdministration" role="menu" style="width: 200px">
					<sec:authorize
						access="hasAnyAuthority('${PERMISSION_FACILITY_CREATE}, ${PERMISSION_FACILITY_EDIT_ALL}, ${PERMISSION_FACILITY_EDIT_CURRENT}')">
						<li role="menuitem"><a href="${home}/facilityEdit.htm"
							title="Manage Facilities" shortcut="mf"
							class="sequencehotkeyed" role="menuitem">Manage Facilities</a>
						</li>
					</sec:authorize>
					<sec:authorize
						access="hasAnyAuthority('${PERMISSION_ORG_CODE_NATIONAL_READ}, 
													 ${PERMISSION_ORG_CODE_LOCAL_READ}')">
						<li role="menuitem"><a href="${home}/organizationList.htm"
							title="Manage Organizations" shortcut="mo"
							class="sequencehotkeyed" role="menuitem">Manage Organizations</a>
						</li>
					</sec:authorize>
					<sec:authorize
						access="hasAnyAuthority('${PERMISSION_PERM_CODE_SERVICE_READ}, 
													 ${PERMISSION_PERM_CODE_SERVICE_CREATE}')">
						<li role="menuitem"><a
							href="${home}/editVoluntaryService.htm"
							title="Edit Vountary Service" shortcut="evs"
							class="sequencehotkeyed" role="menuitem">Manage Voluntary
								Service</a></li>
					</sec:authorize>
					<li role="menuitem"><a
						href="javascript:popupOrganizationSearch('menuSearch')"
						title="Search for Organization" shortcut="sv"
						class="sequencehotkeyed" role="menuitem">Search for
							Organization</a></li>
				</ul></li>
			<%--
			<c:if test="${multipleStationsAssigned or hasNationalAdminRole}">
				<li role="menuitem"><a href="${home}/changeStation.htm"
					title="Change Facility" shortcut="cs" class="sequencehotkeyed"
					role="menuitem">Change Facility</a></li>
			</c:if>
			 --%>
			<li role="menuitem" aria-haspopup="true"><a href="#"
				title="Reference" shortcut="Shift+f" class="hotkeyed"
				id="menuReferenceAnchor" role="menuitem">Reference</a>
				<ul id="menuReference" role="menu" style="width: 165px">
					<%-- Populated in CommonReferenceDataInterceptor via a Velocity template in the DB - CPB --%>
					${referenceDataLinks}
				</ul></li>

			<c:set var="isRoleManager" value="false" />
			<sec:authorize access="hasAuthority('${PERMISSION_USER_MANAGER}')">
				<c:set var="isRoleManager" value="true" />
			</sec:authorize>
			<li role="menuitem"><a href="${home}/userAdmin.htm"
				title="Manage User Access" shortcut="cs" class="sequencehotkeyed"
				role="menuitem"><c:if test="${isRoleManager}">Manage User Access</c:if>
					<c:if test="${not isRoleManager}">Manage My User</c:if></a></li>
		</ul>
	</div>
</div>

<script type="text/javascript">
	function accessAdHocReports() {
		var url = "javascript:ssrs()";
		var windowName = "VSS_Ad_Hoc_Reporting"
		// var windowSize = "width=800,height=700,scrollbars=yes"
		window.open(url, windowName)
	}

	/**
	 * This implementation of the menu is based on HFE suggestion that
	 * the menu will only open when it is clicked instead of the default
	 * which is opening the menu when you do a mouse over
	 
	 *  added by jtorreno 6.28.2012
	 */
	function initializeMenu() {
		accessibleDropdownMenu('#navigationMenuBar', 100);
	}

	$(function() {
		initializeMenu()

		$('.search_show_hide').showHide({
			speed : 300,
			easing : '',
			changeText : 0
		})

		/*
		$(".hotkeyed").each(function() {
			var hotKey = $(this).attr('shortcut')
			var elemBeingKeyed = $(this)
			$(document).bind('keydown', hotKey, function() {
				//Close the expanded menus if any
				$('li.hover').each(function() {
					var classHoverLi = $(this).attr('class')
					var classHoverLiRemoved = classHoverLi.replace('hover', "")
					$(this).attr('class', classHoverLiRemoved)
				})
				//Expand the appropiate menu as needed
				elemBeingKeyed.parent().trigger('mouseover')
				elemBeingKeyed.focus();
				window.location = elemBeingKeyed.attr('href')
			})
		})
		
		$(".sequencehotkeyed").each(function() {
			var hotKeySequence = $(this).attr('shortcut')
			var hotKey1 = hotKeySequence.substring(0, 1)
			var hotKey2 = hotKeySequence.substring(1, 2)
			var elemBeingKeyed = $(this)

			$(document).mapHotKeys([ $.mapHotKeys.createSequence(hotKey1, hotKey2, $(document), function(key) {
				//Close the expanded menus if any
				$('li.hover').each(function() {
					var classHoverLi = $(this).attr('class')
					var classHoverLiRemoved = classHoverLi.replace('hover', "")
					$(this).attr('class', classHoverLiRemoved)
				})
				//Expand the appropriate menu as needed
				window.location = elemBeingKeyed.attr('href')
			}) ])
		})
		 */

		// Adding a span with empty title to all anchors with role=menuitem so as to avoid
		// mouseover display of title on anchor tags. These titles
		// currently hold the shortcut key sequence to invoke the specific menu option.
		$("a[role='menuitem']").each(function() {
			var currentContent = $(this).html()
			$(this).html("<span title=''>" + currentContent + "</span>")
		})
	})
</script>
