package gov.va.vss.service.batch;

import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import gov.va.vss.model.jobExecution.JobExecutionResultItem;
import gov.va.vss.service.impl.JobExecutionResultItemServiceImpl;

@Service
@Profile({ "default" })
public class JobExecutionResultItemServiceForTestingImpl extends JobExecutionResultItemServiceImpl
		implements JobExecutionResultItemService {

	public static boolean allowJobExecutionResultItemsWithExceptions = false;

	@Override
	public JobExecutionResultItem saveOrUpdate(JobExecutionResultItem result) {
		if (allowJobExecutionResultItemsWithExceptions)
			return super.saveOrUpdate(result);

		Exception statusException = result.getStatusException();
		if (statusException != null)
			throw new RuntimeException(statusException);
		return super.saveOrUpdate(result);
	}

}
